/* ----------------------------------------------------------------------------
 * --  _____       ______  _____                                              -
 * -- |_   _|     |  ____|/ ____|                                             -
 * --   | |  _ __ | |__  | (___    Institute of Embedded Systems              -
 * --   | | | '_ \|  __|  \___ \   Zuercher Hochschule Winterthur             -
 * --  _| |_| | | | |____ ____) |  (University of Applied Sciences)           -
 * -- |_____|_| |_|______|_____/   8401 Winterthur, Switzerland               -
 * ----------------------------------------------------------------------------
 */
/**
 * @file
 * @brief Lab implementation
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "person.h"
#include "list.h"
#include "read.h"

int toupper(int ch);


/**
 * @brief Main entry point.
 * @param[in] argc  The size of the argv array.
 * @param[in] argv  The command line arguments...
 * @returns Returns EXIT_SUCCESS (=0) on success, EXIT_FAILURE (=1) there is an expression syntax error.
 */
int main(int argc, char* argv[])
{
	// BEGIN-STUDENTS-TO-ADD-CODE
    char command;
    char input;
    int end = 0;
    while(end == 0){
        printf("\nPlease choose a command:\nI(nsert)\nR(emove)\nS(how)\nC(lear)\nE(nd)\n");
        input = getchar();
        command = input;
        while((input != EOL) && (input != EOF)){
            input = getchar();
        }
        command = toupper(command);
        switch(command){
            case 73: // I
                insertPerson();
                break;
            case 82: // R
                removePerson();
                break;
            case 83: // S
                showPerson();
                break;
            case 67: // C
                clearPerson();
                break;
            case 69: // E
                end = 1;
                printf("\nProgramm is ending\n");
                break;
            default:
                printf("\nCommand not found!\n");
        }
    }

    
	// END-STUDENTS-TO-ADD-CODE
    return EXIT_SUCCESS;
}
